import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { OpenCodeGraphItemChipList } from '@opencodegraph/ui-react';
import { useMemo } from 'react';
import { createRoot } from 'react-dom/client';
import { openCodeGraphData, showOpenCodeGraphDecorations } from './extension';
export function useOpenCodeGraphExtension({ visibility, annotations, }) {
    // TODO(sqs): useCompartment results in sometimes the facet data being stale because the editor is reconfigured
    return useMemo(() => visibility
        ? [
            openCodeGraphData(annotations),
            showOpenCodeGraphDecorations({
                visibility,
                createDecoration(container, { indent, items }) {
                    const root = createRoot(container);
                    root.render(_jsx(Indented, { indent: indent, children: _jsx(OpenCodeGraphItemChipList, { items: items, chipClassName: "ocg-chip", popoverClassName: "ocg-chip-popover" }) }));
                    return {
                        destroy() {
                            root.unmount();
                        },
                    };
                },
            }),
        ]
        : [], [visibility, annotations]);
}
/**
 * Indents the children by the specified whitespace. This is used to align OCG item chips with the
 * non-whitespace characters on the line they're attached to.
 */
const Indented = ({ indent, children }) => (
// eslint-disable-next-line react/forbid-dom-props
_jsxs("div", { style: { display: 'flex' }, children: [_jsx("pre", { style: { height: 0, overflow: 'hidden', visibility: 'hidden' }, children: indent }), children] }));
//# sourceMappingURL=useOpenCodeGraphExtension.js.map